#include <iostream>
#include <fstream>
#include <vector>
#include <stdlib.h>

using namespace std;

string parse(string line)
{
    int pos = line.find_first_of(">");
    line = line.substr(pos+1);
    pos = line.find_first_of("<");
    return line.substr(0,pos);
}

struct Riik
{
    string nimi;
    float rahvaarv;
    int pindala;
    float tihedus;
    float erinevus;
};
vector<Riik> riigid;

int main()
{
   ifstream in("..\\..\\EuroopaRiigid.xml");
   if(!in.is_open())
   {
      cout<<"Faili ei saa avada!\n";
      return 1;
   }

    int inimesi=0, pind=0;
   string line;
   getline(in,line);
   //cout<<line<<endl;
   while(in.good())
   {
      getline(in,line);
      //cout<<line<<endl;  // <EuroopaRiik>
      if(line[1]=='/')
          break;

      Riik uus;
      getline(in,line);   // Nimi
      //cout<<parse(line)<<endl;
      uus.nimi = parse(line);

      getline(in,line);   // Rahvaarv
      //cout<<parse(line)<<endl;
      string r = parse(line);   // "6347,5"
      int k = r.find_first_of(",");
      int x = atoi(r.substr(0,k).c_str());
      int y = atoi(r.substr(k+1).c_str());
      uus.rahvaarv = 1000*x+100*y;

      getline(in,line);    // Pindala
      //cout<<parse(line)<<endl;
      string p = parse(line);
      uus.pindala = atoi(p.c_str());
      uus.tihedus = uus.rahvaarv/uus.pindala;
      cout<<uus.tihedus<<"\t"<<uus.nimi<<endl;

      inimesi += uus.rahvaarv;
      pind += uus.pindala;

      getline(in,line);    // </EuroopaRiik>
      riigid.push_back(uus);
   }
   in.close();

   float keskmine = inimesi/pind;
   cout<<"\nKeskmine tihedus "<<keskmine<<endl;
    for(int k=0;k<riigid.size();k++)
    {
        float delta = riigid[k].tihedus-keskmine;
        if(delta<0)
            delta = -delta;
        riigid[k].erinevus = delta;

        cout<<delta<<"\t"<<riigid[k].nimi<<endl;
    }

    return 0;
}
